﻿using BepInEx;
using Comfort.Common;
using EFT.UI;
using System.Linq;
using UnityEngine.UI;

namespace UIScaler
{
    [BepInPlugin("com.ShittyUIScaler", "Shitty UI Scaler", "1.0.0")]
    public class Plugin : BaseUnityPlugin
    {
        private bool commonUiScaled = false;
        private bool preloaderUiScaled = false;
        private bool menuUiScaled = false;
        private bool battleUiScaled = false;

        private void Awake()
        {
            Logger.LogInfo("ShittyUIScaler is loaded!");
        }

        private void OnDestroy()
        {
            Logger.LogInfo("ShittyUIScaler is loaded!");
        }

        private void FixedUpdate()
        {
            ScaleUI();
        }

        private void ScaleUI()
        {
            if (Singleton<CommonUI>.Instance != null && !commonUiScaled)
            {
                Singleton<CommonUI>.Instance.transform.GetChildren().ToList().ForEach(x =>
                {
                    if (x.GetComponent<CanvasScaler>() != null)
                    {
                        x.GetComponent<CanvasScaler>().scaleFactor = 1f;
                    }
                });

                commonUiScaled = true;
            }

            if (Singleton<PreloaderUI>.Instance != null && !preloaderUiScaled)
            {
                Singleton<PreloaderUI>.Instance.transform.GetChildren().ToList().ForEach(x =>
                {
                    if (x.GetComponent<CanvasScaler>() != null)
                    {
                        x.GetComponent<CanvasScaler>().scaleFactor = 1f;
                    }
                });

                preloaderUiScaled = true;
            }

            if (Singleton<MenuUI>.Instance != null && !menuUiScaled)
            {
                Singleton<MenuUI>.Instance.transform.GetChildren().ToList().ForEach(x =>
                {
                    if (x.GetComponent<CanvasScaler>() != null)
                    {
                        x.GetComponent<CanvasScaler>().scaleFactor = 1f;
                    }
                });

                menuUiScaled = true;
            }

            if (Singleton<BattleUIScreen>.Instance != null && !battleUiScaled)
            {
                Singleton<BattleUIScreen>.Instance.transform.GetChildren().ToList().ForEach(x =>
                {
                    if (x.GetComponent<CanvasScaler>() != null)
                    {
                        x.GetComponent<CanvasScaler>().scaleFactor = 1f;
                    }
                });

                battleUiScaled = true;
            }
        }
    }
}
